﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading;
using System.Collections;

namespace FileMonitor
{

    public partial class Form1 : Form
    {
        private int TimeoutMillis = 2000;
        System.IO.FileSystemWatcher fsw = new System.IO.FileSystemWatcher();
        WatcherTimer watcher = null;
        public Form1()
        {
            InitializeComponent();
            watcher = new WatcherTimer(fsw_Changed, TimeoutMillis);
        }

        private void fileWatcher_Created(object sender, System.IO.FileSystemEventArgs e)
        {
            string file = e.FullPath;
            MessageBox.Show(file);
            System.Diagnostics.Process.Start("notepad.exe", file);

        }

        private void bt_set_Click(object sender, EventArgs e)
        {
            if (tb_folder.Text.Trim().Length == 0)
            {
                tb_folder.Text = @".";
            }

            fsw.Path = tb_folder.Text;
            fsw.NotifyFilter = 0;
            
            /* Watch for changes in LastAccess and LastWrite times, and 
               the renaming of files or directories. */
            if (ckb_Attributes.Checked)
            {
                fsw.NotifyFilter |= NotifyFilters.Attributes;
            }
            if (ckb_DirectoryName.Checked)
            {
                fsw.NotifyFilter |= NotifyFilters.DirectoryName;
            }
            if (ckb_FileName.Checked)
            {
                fsw.NotifyFilter |= NotifyFilters.FileName;
            }
            if (ckb_LastAccess.Checked)
            {
                fsw.NotifyFilter |= NotifyFilters.LastAccess;
            }
            if (ckb_LastWrite.Checked)
            {
                fsw.NotifyFilter |= NotifyFilters.LastWrite;
            }
            if (ckb_Size.Checked)
            {
                fsw.NotifyFilter |= NotifyFilters.Size;
            }
            if (ckb_CreationTime.Checked)
            {
                fsw.NotifyFilter |= NotifyFilters.CreationTime;
            }



            // Only watch text files.
            fsw.Filter = "*.*";

            // Add event handlers.
            //fsw.Created += new FileSystemEventHandler(fsw_Changed);
            //fsw.Changed += new FileSystemEventHandler(fsw_Changed);
            fsw.Created += new FileSystemEventHandler(watcher.OnFileChanged);
            fsw.Changed += new FileSystemEventHandler(watcher.OnFileChanged);

            

            // Begin watching.
            fsw.EnableRaisingEvents = true;

            // Create the timer that will be used to deliver events. Set as disabled
            //if (m_timer == null)
            //{
            //    //设置定时器的回调函数。此时定时器未启动
            //    m_timer = new System.Threading.Timer(new TimerCallback(OnWatchedFileChange), null, Timeout.Infinite, Timeout.Infinite);
            //}


        }

        void fsw_Changed(object sender, FileSystemEventArgs e)
        {
            MessageBox.Show(e.ChangeType.ToString(), e.Name);

            //Mutex mutex = new Mutex(false, "FSW");
            //mutex.WaitOne();
            //if (!files.Contains(e.Name))
            //{
            //    files.Add(e.Name);
            //}
            //mutex.ReleaseMutex();
             
            ////重新设置定时器的触发间隔，并且仅仅触发一次
            //m_timer.Change(TimeoutMillis, Timeout.Infinite);
        }


        private void bt_exit_Click(object sender, EventArgs e)
        {
            this.Close();
        }



    }
}
